#!/bin/bash
export TIMEFORMAT='%3R'
compound_queries=( "../queries/q01.sparql" "../queries/q02.sparql" "../queries/q05.sparql" "../queries/q06.sparql" "../queries/q09.sparql" "../queries/q10.sparql" "../queries/q13.sparql" "../queries/q14.sparql" "../queries/q17.sparql" "../queries/q18.sparql" "../queries/q21.sparql")
target_queries=( "../queries/q03.sparql" "../queries/q04.sparql" "../queries/q07.sparql" "../queries/q08.sparql" "../queries/q11.sparql" "../queries/q12.sparql" "../queries/q15.sparql" "../queries/q16.sparql" "../queries/q19.sparql" "../queries/q20.sparql" "../queries/q22.sparql" "../queries/q23.sparql" "../queries/q24.sparql" "../queries/q25.sparql" "../queries/q26.sparql" "../queries/q27.sparql" "../queries/q28.sparql" "../queries/q29.sparql" "../queries/q30.sparql" "../queries/q31.sparql" "../queries/q32.sparql" "../queries/q33.sparql" )
for query in ${compound_queries[@]}
do
	STARTTIME=$(date +%s)
	out_file=`echo $query | sed -e 's,.sparql,_times.txt,' -e 's,queries,results/sesame-native,'` 
	if [ ! -f $out_file ]; then
		cat $query | sed -e "s,RESOURCE,`head -n 1 ../resources/compounds/sample_compounds.txt`,g"
		echo
		echo $out_file
		while read compound
		do 
			current_sparql=`sed -e "s,RESOURCE,${compound},g" $query`;
			current_sparql="$current_sparql"
			if [[ -z "$ENDTIME" ]]; then
				echo $current_sparql
			fi
			time curl --data-urlencode "query=${current_sparql}" http://localhost:8080/openrdf-sesame/repositories/sesame-native 1>/dev/null 2>/dev/null
			ENDTIME=$(date +%s)
			if [ $(($ENDTIME - $STARTTIME)) -gt 1000 ]; then
				break
			fi
		done < ../resources/compounds/sample_compounds.txt &> $out_file
	fi
done
echo "Finished compounds, starting targets"
for query in ${target_queries[@]}
do
        STARTTIME=$(date +%s)
        out_file=`echo $query | sed -e 's,.sparql,_times.txt,' -e 's,queries,results/sesame-native,'` 
        if [ ! -f $out_file ]; then
		cat $query | sed -e "s,RESOURCE,`head -n 1 ../resources/targets/sample_targets.txt`,g"
		echo
                echo $out_file
                while read target
                do 
                        current_sparql=`sed -e "s,RESOURCE,${target},g" $query`;
                        current_sparql="$current_sparql"
                        if [[ -z "$ENDTIME" ]]; then
                                echo $current_sparql
                        fi
                        time curl --data-urlencode "query=${current_sparql}" http://localhost:8080/openrdf-sesame/repositories/sesame-native 1>/dev/null 2>/dev/null
                        ENDTIME=$(date +%s)
                        if [ $(($ENDTIME - $STARTTIME)) -gt 1000 ]; then
                                break
                        fi
                done < ../resources/targets/sample_targets.txt &> $out_file
        fi
done
